/// @file

#ifndef GEM_READOUT_EXCEPTION_EXCEPTION_H
#define GEM_READOUT_EXCEPTION_EXCEPTION_H

#include <gem/utils/exception/Exception.h>

#define GEM_READOUT_DEFINE_EXCEPTION(EXCEPTION_NAME) GEM_DEFINE_EXCEPTION(EXCEPTION_NAME, readout)
GEM_READOUT_DEFINE_EXCEPTION(ConfigurationParseProblem)
GEM_READOUT_DEFINE_EXCEPTION(ConfigurationProblem)
GEM_READOUT_DEFINE_EXCEPTION(ConfigurationValidationProblem)
GEM_READOUT_DEFINE_EXCEPTION(Exception)
GEM_READOUT_DEFINE_EXCEPTION(HardwareProblem)
GEM_READOUT_DEFINE_EXCEPTION(InfoSpaceProblem)
GEM_READOUT_DEFINE_EXCEPTION(RCMSNotificationError)
GEM_READOUT_DEFINE_EXCEPTION(ReadoutProblem)
GEM_READOUT_DEFINE_EXCEPTION(SOAPCommandParameterProblem)
GEM_READOUT_DEFINE_EXCEPTION(SOAPException)
GEM_READOUT_DEFINE_EXCEPTION(SoftwareProblem)
GEM_READOUT_DEFINE_EXCEPTION(TransitionProblem)
GEM_READOUT_DEFINE_EXCEPTION(ValueError)

#define GEM_READOUT_DEFINE_ALARM(ALARM_NAME) GEM_READOUT_DEFINE_EXCEPTION(ALARM_NAME)
GEM_READOUT_DEFINE_ALARM(MonitoringFailureAlarm)

#endif // GEM_READOUT_EXCEPTION_EXCEPTION_H
